<template>
  <div>
    <div class="main-info-wrap">
      <v-row>
        <v-col cols="4" class="py-10">
          <v-dialog fullscreen v-model="dialogCrmName" hide-overlay transition="dialog-bottom-transition">
            <template v-slot:activator="{ on, attrs }">
              <v-card>
                <v-card-title>Инфо о CRM</v-card-title>
                <v-card-actions width="100%">
                  <v-btn
                      class="ml-auto"
                      v-bind="attrs"
                      v-on="on"
                      color="primary"
                  >
                    открыть
                  </v-btn>
                </v-card-actions>
              </v-card>
            </template>
            <v-card>
              <v-toolbar
                  dark
                  color="primary"
                  height="60px"
              >
                <v-btn
                    icon
                    dark
                    @click="dialogCrmName = false"
                >
                  <v-icon>mdi-close</v-icon>
                </v-btn>
                <v-toolbar-title>Сделки</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                  <v-text-field label="Поиск"/>
                  <v-dialog
                      v-model="dialogAddInfo"
                      width="500"
                  >
                    <template  v-slot:activator="{ on, attrs }">
                      <v-btn v-bind="attrs" v-on="on" text>
                        Добавить <v-icon>mdi-plus</v-icon>
                      </v-btn>
                    </template>
                    <v-card>
                      <v-card-title>
                        <span class="text-h5">Новое обьявление</span>
                      </v-card-title>

                      <v-card-text>
                        <v-container>
                          <v-row>
                            <v-col cols="12" class="d-flex">
                              <v-text-field
                                  v-model="newLeadInfo.name"
                                  label="Название"
                                  class="mr-2"
                              ></v-text-field>
                              <v-text-field
                                  v-model="newLeadInfo.title"
                                  label="Заголовок"
                              ></v-text-field>
                            </v-col>
                            <v-col
                                cols="12"
                            >
                              <v-textarea
                                  v-model="newLeadInfo.comments"
                                  label="Текст обьявления"
                              ></v-textarea>
                            </v-col>
                            <v-col
                                cols="12"
                            >
                              <div class="mb-4 d-flex align-center justify-space-between">
                                <div class="text-center" style="font-size: 16px">Цвет блока</div>
                                <div style="width: 100%; height: 15px; border: 1px black dashed;margin: 0 10px; border-radius: 5px" :style="{backgroundColor: newLeadInfo.background}"></div>
                                <v-menu
                                    v-model="menu.background"
                                    :close-on-content-click="false"
                                    :nudge-width="200"
                                    offset-x
                                >
                                  <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        text
                                        rounded
                                        outlined
                                        small
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                      изменить
                                    </v-btn>
                                  </template>
                                  <v-card>
                                    <v-color-picker
                                        v-model="newLeadInfo.background"
                                        flat
                                        hide-inputs
                                        class="mx-auto"
                                    ></v-color-picker>
                                    <v-card-actions>
                                      <v-spacer></v-spacer>

                                      <v-btn
                                          text
                                          @click="menu.background = false"
                                          small
                                      >
                                        Отмена
                                      </v-btn>
                                      <v-btn
                                          color="primary"
                                          text
                                          @click="menu.background = false"
                                          small
                                      >
                                        Сохранить
                                      </v-btn>
                                    </v-card-actions>
                                  </v-card>

                                </v-menu>
                              </div>
                              <div class="d-flex align-center justify-space-between">
                                <div class="text-center" style="font-size: 16px">Цвет текста</div>
                                <div style="width: 100%; height: 15px; border: 1px black dashed;margin: 0 10px; border-radius: 5px" :style="{backgroundColor: newLeadInfo.color}"></div>
                                <v-menu
                                    v-model="menu.color"
                                    :close-on-content-click="false"
                                    :nudge-width="200"
                                    offset-x
                                >
                                  <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        text
                                        rounded
                                        outlined
                                        small
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                      Изменить
                                    </v-btn>
                                  </template>
                                  <v-card>
                                    <v-color-picker
                                        v-model="newLeadInfo.color"
                                        flat
                                        hide-inputs
                                        class="mx-auto"
                                    ></v-color-picker>
                                    <v-card-actions>
                                      <v-spacer></v-spacer>

                                      <v-btn
                                          text
                                          small
                                          @click="menu.color = false"
                                      >
                                        Отмена
                                      </v-btn>
                                      <v-btn
                                          color="primary"
                                          text
                                          small
                                          @click="menu.color = false"
                                      >
                                        Сохранить
                                      </v-btn>
                                    </v-card-actions>
                                  </v-card>

                                </v-menu>
                              </div>

                            </v-col>
                            <v-col
                                cols="12"
                            >
                              <v-sheet class="pa-5">
                                <v-switch
                                    v-model="newLeadInfo.see"
                                    inset
                                    :label="`Видимость: ${newLeadInfo.see ? 'Показывать': 'Скрыто'}`"
                                ></v-switch>
                              </v-sheet>
                            </v-col>
                          </v-row>
                        </v-container>
                      </v-card-text>

                      <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn
                            color="blue darken-1"
                            text
                            @click="close"
                        >
                          Закрыть
                        </v-btn>
                        <v-btn
                            color="blue darken-1"
                            text
                            @click="addLeadInfo"
                        >
                          Сохранить
                        </v-btn>
                      </v-card-actions>
                    </v-card>
                  </v-dialog>
                </v-toolbar-items>
              </v-toolbar>
              <v-row>
                <v-col cols="6" sm="5" lg="4" class="mx-auto">
                  <v-text-field label="Адрес CRM"/>
                </v-col>
                <v-col cols="6" sm="5" lg="4" class="mx-auto">
                  <v-text-field label="Название компании"/>
                </v-col>
              </v-row>
            </v-card>
          </v-dialog>
        </v-col>
        <v-col cols="4" class="py-10">
          <v-dialog fullscreen v-model="dialogInfo" hide-overlay transition="dialog-bottom-transition">
            <template v-slot:activator="{ on, attrs }">
              <v-card>
                <v-card-title>Объявления</v-card-title>
                <v-card-actions width="100%">
                  <v-btn
                      class="ml-auto"
                      v-bind="attrs"
                      v-on="on"
                      color="primary"
                  >
                    открыть
                  </v-btn>
                </v-card-actions>
              </v-card>
            </template>
            <v-card>
              <v-toolbar
                  dark
                  color="primary"
                  height="60px"
              >
                <v-btn
                    icon
                    dark
                    @click="dialogInfo = false"
                >
                  <v-icon>mdi-close</v-icon>
                </v-btn>
                <v-toolbar-title>Сделки</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                  <v-text-field label="Поиск"/>
                  <v-dialog
                      v-model="dialogAddInfo"
                      width="500"
                  >
                    <template  v-slot:activator="{ on, attrs }">
                      <v-btn v-bind="attrs" v-on="on" text>
                        Добавить <v-icon>mdi-plus</v-icon>
                      </v-btn>
                    </template>
                    <v-card>
                      <v-card-title>
                        <span class="text-h5">Новое обьявление</span>
                      </v-card-title>

                      <v-card-text>
                        <v-container>
                          <v-row>
                            <v-col cols="12" class="d-flex">
                              <v-text-field
                                  v-model="newLeadInfo.name"
                                  label="Название"
                                  class="mr-2"
                              ></v-text-field>
                              <v-text-field
                                  v-model="newLeadInfo.title"
                                  label="Заголовок"
                              ></v-text-field>
                            </v-col>
                            <v-col
                                cols="12"
                            >
                              <v-textarea
                                  v-model="newLeadInfo.comments"
                                  label="Текст обьявления"
                              ></v-textarea>
                            </v-col>
                            <v-col
                                cols="12"
                            >
                              <div class="mb-4 d-flex align-center justify-space-between">
                                <div class="text-center" style="font-size: 16px">Цвет блока</div>
                                <div style="width: 100%; height: 15px; border: 1px black dashed;margin: 0 10px; border-radius: 5px" :style="{backgroundColor: newLeadInfo.background}"></div>
                                <v-menu
                                    v-model="menu.background"
                                    :close-on-content-click="false"
                                    :nudge-width="200"
                                    offset-x
                                >
                                  <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        text
                                        rounded
                                        outlined
                                        small
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                      изменить
                                    </v-btn>
                                  </template>
                                  <v-card>
                                    <v-color-picker
                                        v-model="newLeadInfo.background"
                                        flat
                                        hide-inputs
                                        class="mx-auto"
                                    ></v-color-picker>
                                    <v-card-actions>
                                      <v-spacer></v-spacer>

                                      <v-btn
                                          text
                                          @click="menu.background = false"
                                          small
                                      >
                                        Отмена
                                      </v-btn>
                                      <v-btn
                                          color="primary"
                                          text
                                          @click="menu.background = false"
                                          small
                                      >
                                        Сохранить
                                      </v-btn>
                                    </v-card-actions>
                                  </v-card>

                                </v-menu>
                              </div>
                              <div class="d-flex align-center justify-space-between">
                                <div class="text-center" style="font-size: 16px">Цвет текста</div>
                                <div style="width: 100%; height: 15px; border: 1px black dashed;margin: 0 10px; border-radius: 5px" :style="{backgroundColor: newLeadInfo.color}"></div>
                                <v-menu
                                    v-model="menu.color"
                                    :close-on-content-click="false"
                                    :nudge-width="200"
                                    offset-x
                                >
                                  <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        text
                                        rounded
                                        outlined
                                        small
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                      Изменить
                                    </v-btn>
                                  </template>
                                  <v-card>
                                    <v-color-picker
                                        v-model="newLeadInfo.color"
                                        flat
                                        hide-inputs
                                        class="mx-auto"
                                    ></v-color-picker>
                                    <v-card-actions>
                                      <v-spacer></v-spacer>

                                      <v-btn
                                          text
                                          small
                                          @click="menu.color = false"
                                      >
                                        Отмена
                                      </v-btn>
                                      <v-btn
                                          color="primary"
                                          text
                                          small
                                          @click="menu.color = false"
                                      >
                                        Сохранить
                                      </v-btn>
                                    </v-card-actions>
                                  </v-card>

                                </v-menu>
                              </div>

                            </v-col>
                            <v-col
                                cols="12"
                            >
                              <v-sheet class="pa-5">
                                <v-switch
                                    v-model="newLeadInfo.see"
                                    inset
                                    :label="`Видимость: ${newLeadInfo.see ? 'Показывать': 'Скрыто'}`"
                                ></v-switch>
                              </v-sheet>
                            </v-col>
                          </v-row>
                        </v-container>
                      </v-card-text>

                      <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn
                            color="blue darken-1"
                            text
                            @click="close"
                        >
                          Закрыть
                        </v-btn>
                        <v-btn
                            color="blue darken-1"
                            text
                            @click="addLeadInfo"
                        >
                          Сохранить
                        </v-btn>
                      </v-card-actions>
                    </v-card>
                  </v-dialog>
                </v-toolbar-items>
              </v-toolbar>
              <v-expansion-panels v-if="items.length">
                <v-expansion-panel
                    v-for="(item, index) in items"
                    :key="item._id"
                >
                  <v-expansion-panel-header v-slot="{ open }">
                    <v-row no-gutters>
                      <v-col cols="4">
                        {{item.name}}
                      </v-col>
                      <v-col
                          cols="8"
                          class="text--secondary"
                      >
                        <v-fade-transition leave-absolute>
                <span
                    v-if="open"
                    key="0"
                >
                  Редактирование
                </span>
                          <span
                              v-else-if="item.see"
                              key="1"
                          >
                  {{item.views.length && 'Видят только: ' || 'Видно всем'}} <v-chip small v-for="el in  item.views" :key="el._id" class="mr-1">{{el.value}}</v-chip>
                </span>
                          <span
                              v-else
                              key="1"
                          >
                  Скрыто для всех
                </span>
                        </v-fade-transition>
                      </v-col>
                    </v-row>
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <v-row no-gutters>
                      <v-spacer></v-spacer>
                      <v-col cols="7" class="mr-2 mr-sm-4">
                        <v-text-field v-model="item.name" :value="item.name" label="Название"/>
                        <v-text-field v-model="item.title" :value="item.title" label="Заголовок"/>
                        <v-textarea
                            v-model="item.comments"
                            :value="item.comments"
                            background-color="#fff"
                            color="black"
                            label="Текст информации"
                        />
                      </v-col>
                      <v-col cols="3">
                        Кому видно
                        <div style="font-size: 12px; opacity: .7; font-style: italic">Если ничего не указано, то видно всем</div>
                        <v-select
                            v-model="item.views"
                            :items="roles"
                            item-text="value"
                            item-value="value"
                            chips
                            flat
                            multiple
                            persistent-hint
                            return-object
                            single-line
                            placeholder="Какие роли могут видеть"
                        ></v-select>
                        <v-sheet class="pa-5">
                          <v-switch
                              v-model="item.see"
                              inset
                              :label="`Видимость: ${item.see ? 'Показывать': 'Скрыто'}`"
                          ></v-switch>
                        </v-sheet>
                      </v-col>
                    </v-row>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn
                          text
                          color="red"
                          @click="deleteLeadInfo(index)"
                          :loading="loadingDeleteLeadInfo"
                      >
                        Удалить
                      </v-btn>
                      <v-btn
                          text
                          color="primary"
                          @click="changeLeadInfo(item)"
                          :loading="loadingSaveLeadInfo"
                      >
                        Сохранить
                      </v-btn>
                    </v-card-actions>
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
            </v-card>
          </v-dialog>
        </v-col>
      </v-row>
    </div>
  </div>
</template>

<script>
import api from '@/API/api'

export default {
  name: 'MainSettings',
  data: () => ({
    date: null,
    dialogCrmName: false,
    dialogInfo: false,
    dialogAddInfo: false,
    loadingSaveLeadInfo: false,
    loadingDeleteLeadInfo: false,
    menu: {
      color: false,
      background: false,
    },
    newLeadInfo: {
      name: "",
      background: "#fff",
      color: "#000",
      title: "",
      comments: "",
      views: [],
      see: true,
    },
    items: [],
    roles: [],
  }),
  created () {
    this.initialize()
  },
  methods: {
    async initialize() {
      await api.getLeadInfo().then(res => this.items = res.data.leadInfo)
      await api.getRoles().then(res => this.roles = res.data.roles)
    },
    async changeLeadInfo(item) {
      this.loadingSaveLeadInfo = true
      await api.changeLeadInfo(item).then(res => res.data.status && (this.loadingSaveLeadInfo = false))
    },
    async deleteLeadInfo(index) {
      this.loadingDeleteLeadInfo = true
      await api.deleteLeadInfo({_id:this.items[index]._id}).then(res => res.data.status && (this.loadingDeleteLeadInfo = false))
      this.items.splice(index, 1)
    },
    async addLeadInfo() {
      await api.addLeadInfo(this.newLeadInfo).then(res => {
        if (res.data.status) {
          this.items.push(this.newLeadInfo)
          this.close()
        }
      })
    },
    close () {
      this.dialogInfo = false
    },
  }
}
</script>

<style scoped lang="scss">
.main-info-wrap {
  display: flex;
  flex-direction: column;
}
</style>
